--
-- Control Mouse
-- Code by Marhu Edit by FirebladeR for FS17 second Edit by Diesel
--
-- Released 
-- V1.0.0.0: 30/10/2016 by FirebladeR (Nitweb.pl) V2.0.0.0: 21/11/2016 by Diesel
--

ControlMouse = {};
ControlMouse.dir = g_currentModDirectory;

function ControlMouse.prerequisitesPresent(specializations)
    return true
end;

function ControlMouse:load(xmlFile)
	
	self.setMotorOrginalWerte = ControlMouse.setMotorOrginalWerte
	
	self.scaleSteering = .5;
	self.scaleValue = 1;
	self.MouseX = 1;
	self.MouseY = 1;
	self.LockKey = true
	self.MouseSteuerX = 0;
	self.MouseSteuerY = 0;
	self.MouseXSensitivity = 1;
	self.MouseYSensitivity = 1;
	self.lastScrollTime = g_currentMission.time
	ControlMouse.MOUSE_WHEEL = false;
			
	for i, camera in ipairs(self.cameras) do
		camera.org_mouseEvent = camera.mouseEvent;
		camera.mouseEvent = function(self, posX, posY, isDown, isUp, button)
			if not self.MouseSteuer or Input.keyPressedState[Input.KEY_lshift] then
				if self.OverWriteAllowTranslation then
					self.allowTranslation = true
					self.OverWriteAllowTranslation = nil
				end
				camera.org_mouseEvent(self, posX, posY, isDown, isUp, button)
			elseif ControlMouse.MOUSE_WHEEL then
				self.allowTranslation = false
				self.OverWriteAllowTranslation = true
			end
		end
    end;
	
	-- Lenkrad
	local dir = ControlMouse.dir
	self.LPic = {x=0.5, y=0.03, w=.0, h=.0*4/3}
	local x, y = self.LPic.x -(self.LPic.w/2), self.LPic.y-(self.LPic.h/2)
	local overlay_path = Utils.getFilename("Lenkrad.dds", dir);
	local overlay = createImageOverlay(overlay_path);
	self.Lenkrad = {overlay = overlay, x = x, y = y, w = self.LPic.w, h = self.LPic.h}

	self.MouseXSensitivity = 1 * self.MouseX;
	self.MouseYSensitivity = 1 * self.MouseY;
	self.Lenkrad.w = self.LPic.w * self.scaleSteering;
	self.Lenkrad.h = self.LPic.h * self.scaleSteering;
	self.Lenkrad.x = self.LPic.x - (self.Lenkrad.w/2)
	self.Lenkrad.y = self.LPic.y - (self.Lenkrad.h/2);
	
	self.ControlMouseDirtyFlag = self:getNextDirtyFlag();
end;

function ControlMouse:delete()
end;

function ControlMouse:mouseEvent(posX, posY, isDown, isUp, button)
	
	if self.cruiseControl then
		if isDown and button == 2 then
			if not self.LockKey then
				self.StartMouseX = posX;
				self.MouseSteuerX = 0;
				self.StartMouseX = posY;
				self.MouseSteuerY = 0;
				self.MouseSteuer = true;
			end
		elseif isUp and button == 2 then
			if self.LockKey then
				self.LockKeySet = true;
			else
				self.MouseSteuer = false;
				self.MouseSteuerX = 0;
				self.MouseSteuerY = 0;
			end
		end;
		if self.LockKey then
			if self.LockKeySet then
				self.LockKeySet = false;
				if self.MouseSteuer then
					self.MouseSteuer = false;
					self.MouseSteuerX = 0;
					self.MouseSteuerY = 0;
				else
					self.StartMouseX = posX;
					self.MouseSteuerX = 0;
					self.StartMouseX = posY;
					self.MouseSteuerY = 0;
					self.MouseSteuer = true;	
				end;
			end;
		end
	end;
	
	self.cameras[self.camIndex].MouseSteuer = self.MouseSteuer;
	
	if self.MouseSteuer and not Input.keyPressedState[Input.KEY_lshift] and not Input.keyPressedState[Input.KEY_lctrl] then
		local minY,maxY=-1,1
		if InputBinding.wrapMousePositionEnabled then
			self.MouseSteuerX = self.MouseSteuerX + (InputBinding.mouseMovementX * self.MouseXSensitivity);
			if self.cruiseControl.state == 0 then
				if ControlMouse.MOUSE_WHEEL then
					if isDown then
						local diff = math.min(math.max(g_currentMission.time - self.lastScrollTime,30),1000) / 100
						if button == Input.MOUSE_BUTTON_WHEEL_UP then
							if self.MouseSteuerY <= 0 and diff <= 0.35 then
								maxY = 0
							end
							self.MouseSteuerY = self.MouseSteuerY + (0.1/diff)
							self.lastScrollTime = g_currentMission.time
						elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
							if self.MouseSteuerY >= 0 and diff <= 0.35 then
								minY = 0
							end
							self.MouseSteuerY = self.MouseSteuerY - (0.1/diff)
							self.lastScrollTime = g_currentMission.time
						end
					end
				else
					self.MouseSteuerY = self.MouseSteuerY + (InputBinding.mouseMovementY * self.MouseYSensitivity);
				end
			end;
		else
			self.MouseSteuerX = self.MouseSteuerX - ((self.StartMouseX - posX)*2*self.MouseXSensitivity)
			if self.cruiseControl.state == 0 then
				if ControlMouse.MOUSE_WHEEL then
					if isDown then
						local diff = math.min(math.max(g_currentMission.time - self.lastScrollTime,30),1000) / 100
						if button == Input.MOUSE_BUTTON_WHEEL_UP then
							self.MouseSteuerY = self.MouseSteuerY + (0.1/diff)
							print(diff)
							if self.movingDirection < 0 and diff <= 0.35 then
								maxY = 0
							end
							self.lastScrollTime = g_currentMission.time
						elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
							self.MouseSteuerY = self.MouseSteuerY - (0.1/diff)
							if self.movingDirection > 0 and diff <= 0.35 then
								minY = 0
							end
							self.lastScrollTime = g_currentMission.time
						end
					end;
				else
					self.MouseSteuerY = self.MouseSteuerY - ((self.StartMouseY - posY)*2*self.MouseYSensitivity);
				end
			end;
		end;

		self.MouseSteuerX = math.max(-1,self.MouseSteuerX)
		self.MouseSteuerX = math.min(1,self.MouseSteuerX)	
		-- if self.movingDirection > 0 and self.lastSpeed > 0.0001 then
			-- self.MouseSteuerY = math.min(1,math.max(0,self.MouseSteuerY))
		-- elseif self.movingDirection < 0 and self.lastSpeed > 0.0001 then
			-- self.MouseSteuerY = math.min(0,math.max(-1,self.MouseSteuerY))
		-- else
			self.MouseSteuerY = math.min(maxY,math.max(minY,self.MouseSteuerY))
			if math.abs(self.MouseSteuerY) < 0.01 then
				self.MouseSteuerY = 0
			end
		--end
		
		self:raiseDirtyFlags(self.ControlMouseDirtyFlag);
	end
	
	self.StartMouseX = posX;
	self.StartMouseY = posY;
end;

function ControlMouse:keyEvent(unicode, sym, modifier, isDown)
end;

function ControlMouse:readUpdateStream(streamId, timestamp, connection)
    if not connection:getIsServer() then
		self.MouseSteuer = streamReadBool(streamId);
		self.MouseSteuerX = streamReadFloat32(streamId);
		self.MouseSteuerY = streamReadFloat32(streamId);
		self.KeyAD_Pressed = streamReadBool(streamId);
		self.KeyWS_Pressed = streamReadBool(streamId);
	end;
end;
 
function ControlMouse:writeUpdateStream(streamId, connection, dirtyMask)
    if connection:getIsServer() then
        streamWriteBool(streamId, self.MouseSteuer);
        streamWriteFloat32(streamId, self.MouseSteuerX);
		streamWriteFloat32(streamId, self.MouseSteuerY);
		streamWriteBool(streamId, self.KeyAD_Pressed);
		streamWriteBool(streamId, self.KeyWS_Pressed);
    end;
end;
 
function ControlMouse:update(dt)
	if self.isEntered and self.isClient and self:getIsActiveForInput(false) and self.cruiseControl then
		-- if self.cruiseControl.state == 0 and not self.KeyWS_Pressed then
			-- if self.MouseSteuerY > 0 then
				-- self.setMotorOrginal = false
				-- self.speedLimit = math.floor(self.motor.maxForwardSpeed*3.6*self.MouseSteuerY+.5);
				-- self.checkSpeedLimit = true;
			-- elseif self.MouseSteuerY < 0 then
				-- self.setMotorOrginal = false
				-- self.speedLimit = math.floor(self.motor.maxBackwardSpeed*3.6*math.abs(self.MouseSteuerY)+.5)
				-- self.checkSpeedLimit = true;
			-- else
				-- self:setMotorOrginalWerte()
			-- end;
			
		-- else 
			-- self:setMotorOrginalWerte()
		-- end;
	end;
end;

function ControlMouse:updateTick(dt)	
	if self.isEntered and self.isClient and self:getIsActiveForInput(false) and self.cruiseControl then
		if  Input.keyPressedState[Input.KEY_a] or Input.keyPressedState[Input.KEY_d] then
			self.KeyAD_Pressed = true;
		else
			self.KeyAD_Pressed = nil;
		end
		if Input.keyPressedState[Input.KEY_w] or Input.keyPressedState[Input.KEY_s] then
			self.KeyWS_Pressed = true;
		else
			self.KeyWS_Pressed = nil;
		end;
	end;
end;

local function showTxt(sl,t,scale,speedLimit)
	setTextAlignment(RenderText.ALIGN_CENTER);
	setTextBold(false)
	local text = "T";
	local c = {0,0.9,1,1}
	if not Input.keyPressedState[Input.KEY_w] and not Input.keyPressedState[Input.KEY_s] then
		if sl == 0 then
			if t then
				text = tostring(math.floor(t*100));
			elseif speedLimit then
				text = tostring(speedLimit);
			end
			c = {1,1,1,1}
		end;
	else
		text = "M"
	end;
	local th = .015 * scale
	local ty = .194 - th/2
	setTextColor(0, 0, 0, 0.75);
	renderText(.815,ty-0.0025,th,text);
	setTextColor(unpack(c));
	renderText(.815,ty,th,text);
	setTextBold(false)
	setTextAlignment(RenderText.ALIGN_LEFT);
end;

local s2 = math.sqrt(2);
local cos, sin, rad = math.cos, math.sin, math.rad;
local function CalculateCorner(angle)
	local r = rad(angle);
	return 0.5 + cos(r) / s2, 0.5 + sin(r) / s2;
end
local function RotateTexture(texture, angle)
	local LRx, LRy = CalculateCorner(angle + 45);
	local LLx, LLy = CalculateCorner(angle + 135);
	local ULx, ULy = CalculateCorner(angle + 225);
	local URx, URy = CalculateCorner(angle - 45);
	
	setOverlayUVs(texture,ULx, ULy, LLx, LLy, URx, URy, LRx, LRy);
end

function ControlMouse:draw()
	if self.MouseSteuer and not self.isHired then
		if self.scaleSteering > 0 then
			--if self.camIndex == 1 and not Input.keyPressedState[Input.KEY_a] and not Input.keyPressedState[Input.KEY_d] then
			if not Input.keyPressedState[Input.KEY_a] and not Input.keyPressedState[Input.KEY_d] then
				RotateTexture(self.Lenkrad.overlay,180*self.MouseSteuerX)
				renderOverlay(self.Lenkrad.overlay,self.Lenkrad.x, self.Lenkrad.y, self.Lenkrad.w, self.Lenkrad.h)
			end;
		end;
		if self.scaleValue > 0 then
			--if self.speedLimit ~= tonumber('inf') then
				if self.MouseSteuerY < 0 then
					local speedLimit = math.floor(self.motor.maxBackwardSpeed*3.6*math.abs(self.MouseSteuerY)+.5)
					showTxt(self.cruiseControl.state, nil, self.scaleValue, -speedLimit);--self.speedLimit
				else
					local speedLimit = math.floor(self.motor.maxForwardSpeed*3.6*self.MouseSteuerY+.5);
					showTxt(self.cruiseControl.state, nil, self.scaleValue, speedLimit);--self.speedLimit
				end
			--else
			--	showTxt(self.cruiseControl.state, self.MouseSteuerY, self.scaleValue, self.motor.speedLimit);
			--end
		end;
	end;
end;

if Drivable.updateVehiclePhysics ~= nil then
	local org_updateVehiclePhysics = Drivable.updateVehiclePhysics
	function Drivable.updateVehiclePhysics(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, doHandbrake, dt)
		if self.MouseSteuer then
			if not self.KeyAD_Pressed then
				axisSideIsAnalog = true;
				axisSide = self.MouseSteuerX;
			end;
			if not self.KeyWS_Pressed then
				axisForwardIsAnalog = true;
				axisForward = -self.MouseSteuerY;
			end;
		end
				
		org_updateVehiclePhysics(self, axisForward, axisForwardIsAnalog, axisSide, axisSideIsAnalog, doHandbrake, dt)
	end;
end;

function ControlMouse:setMotorOrginalWerte()
	if not self.setMotorOrginal then
		self.setMotorOrginal = true
		--self.motor.speedLimit = tonumber('inf');
		self.speedLimit = tonumber('inf');
		self.checkSpeedLimit = false;
		--self.motor.checkSpeedLimit = false;	
	end
end